package gecco.game.dke;


import gecco.server.core.ReferenceHolder;
import gecco.server.core.ActionReturnRequeue;
import gecco.server.core.ActionReturnCompleted;
import gecco.server.core.ActionReturn;


/**
 * ReloadDelayAction.java
 *
 *
 * Created: Mon Mar 10 14:22:02 2003
 *
 * @author <a href="mailto:m-8028@M-8028"></a>
 * @version
 */

public class ReloadDelayAction extends DelayAction {

    StringBuffer sb = new StringBuffer(Def.getInitialReloadingString());
    int nrOfSteps = Def.getNrOfReloadingSteps();
    int remainingSteps = nrOfSteps;

    public ReloadDelayAction (int unitHandle){
	super(unitHandle, ((WarUnit) ReferenceHolder.getUnitManager().
			   getUnit(unitHandle)).getReloadExtendTime());
    }

    public ActionReturn checkPoint(){
	if (firstRun) {
	    firstRun = false;
	    ((WarUnit) getUnit()).setReloadProperty(new String(sb));
	    return new ActionReturnRequeue(delay/nrOfSteps);
	}
	else {
	    remainingSteps--;
	    sb.deleteCharAt(0);
	    if (remainingSteps <= 0) {
		((WarUnit) getUnit()).setReloading(false);
		((WarUnit) getUnit()).updateStatus();
		((WarUnit) getUnit()).setReloadProperty("");
		return new ActionReturnCompleted();
	    }
	    ((WarUnit) getUnit()).setReloadProperty(new String(sb));
	    return new ActionReturnRequeue(delay/nrOfSteps);
	}
    }

}// ReloadDelayAction
