package gecco.game.dke3;

import gecco.server.core.ActionReturn;
import gecco.server.core.ActionReturnCompleted;
import gecco.server.core.ActionReturnRequeue;
import gecco.game.dke.Def;
import gecco.server.core.Unit;
import gecco.server.core.Action;
import gecco.server.core.ReferenceHolder;



/**
 * AutoFireOnAction.java
 *
 *
 * Created: Mon Feb 02 10:10:36 2004
 *
 * @author <a href=mailto:hans.sandstrom@fhs.mil.se> Hans Sandstrm </a>
 * @version 1.0
 */
public class AutoFireWorkerAction extends WarUnitDKE3Action {

    private boolean firstRun = true;

    public AutoFireWorkerAction() {
	super();
    }

    public void initiate(int actionHandle, int unitHandle){
	super.initiate(actionHandle, unitHandle);
	getWarUnitDKE3().setAutoFire(true);
	setInstantaneous(false); 
    }

    private void fireIndirectOn(Unit u){
	Action indirectFireAction = new gecco.game.dke.IndirectFireAction();
	int actionHandle = getNewActionHandle(); // static method gecco.server.core.Action
	double firePosX = u.getX();
	double firePosY = u.getY();
	int shooterHandle = getUnitHandle();
	indirectFireAction.setInstantaneous(false);
	indirectFireAction.initiate(actionHandle, shooterHandle, firePosX, firePosY);
	ReferenceHolder.getActionProcessor().initiateAction(DefDKE3.getSystemRoleName(), 
							    indirectFireAction);
    }
		    

    public ActionReturn checkPoint(){
	if (!(getWarUnitDKE3().isAutoFire())) {
	    getUnit().removeBlockedAction(DefDKE3.getAutoFireOnActionName());
	    return new ActionReturnCompleted(); 
	}
	else {
	    if (getWarUnitDKE3().isReadyForAutoIndirectFire()) {
		Unit u = getWarUnitDKE3().getTargetForAutoIndirectFire();
		if (u != null) { // Target found
		    fireIndirectOn(u);
		} 		
	    }
	    
	    return new ActionReturnRequeue(DefDKE3.getAutoFireCheckDelay());
	}
    }
    
} // AutoFireWorkerAction
