package gecco.game.dke3;

import gecco.server.automaton.AutomatonEvent;
import gecco.server.automaton.AutomatonReturn;
import gecco.server.automaton.AutomatonReturnQueueSelf;
import gecco.server.automaton.AutomatonReturnNoAction;
import gecco.server.core.UnitEvent;



/**
 * AutomatonImplDKE3.java
 *
 *
 * Created: Wed Feb 11 10:31:53 2004
 *
 * @author <a href=mailto:hans.sandstrom@fhs.mil.se> Hans Sandstrm </a>
 * @version 1.0
 */
public class AutomatonImplDKE3 extends gecco.game.dke.AutomatonImpl {

    public AutomatonImplDKE3() {
    }
    
    public AutomatonReturn handleEvent(AutomatonEvent event) {
	if (event.getEventName().equals(DefDKE3.getIndirectFireString())) {
	    setColor(DefDKE3.UNDER_INDIRECT_FIRE);
	    setState(DefDKE3.UNDER_INDIRECT_FIRE);
	    return new AutomatonReturnQueueSelf(DefDKE3.getTimeToShowIndirectFire(),
						new UnitEvent(DefDKE3.getIndirectFireString(),
							      event.getFactor()));
	}
	return new AutomatonReturnNoAction();
    }

    /**
     * For use in DKE3Referee.setInitialOpenRoute(). The boolean argument is
     * only to get a signature that dosen't override partent.
     *
     * @param argLastVisitor an <code>int</code> value
     * @param b a <code>boolean</code> value
     */
    public void setLastVisitor(int argLastVisitor, boolean b){
	setLastVisitor(argLastVisitor, this.x, this.y);
    }
 } // AutomatonImplDKE3
