package gecco.game.dke3;

/**
 * DefDKE3.java
 *
 *
 * Created: Tue Jan 20 16:43:52 2004
 *
 * @author <a href=mailto:hans.sandstrom@fhs.mil.se> Hans Sandstrm </a>
 * @version 1.0
 */
public class DefDKE3 extends gecco.game.dke.Def {

    private static final double MAX_GAME_TIME = 40*60; // game time in seconds

    private static final double AUTO_FIRE_CHECK_DELAY = 5.0;

    private static final String AUTO_FIRE_ON_ACTION_NAME =  "32";
    private static final String AUTO_FIRE_OFF_ACTION_NAME = "33";

    private static final double INDIRECT_FIRE_EXTEND_TIME = 10; // Overrides parent
    private static final double RELOAD_EXTEND_TIME = 40;        // Overrides paren
    private static final double DISTURBED_TIME = 50;

    private static final double COMBAT_EXTEND_TIME = 30;
    
    private static final  int REGAIN_STRENGTH_TIME = 40; // Overrides paren

    private final static double SPEED_FACTOR_ONE = 2.0;
    private final static double SPEED_FACTOR_TWO = 3.0;
    private final static double SPEED_FACTOR_THREE = 4.0;
    private final static double SPEED_FACTOR_FOUR = 6.0;
    private final static double SPEED_FACTOR_FIVE = 8.0;

    public DefDKE3() {
    }

    public static double getMaxGameTime(){
	return MAX_GAME_TIME;
    }

    public static double getAutoFireCheckDelay(){
	return AUTO_FIRE_CHECK_DELAY;
    }

    public static String getAutoFireOnActionName(){
	return AUTO_FIRE_ON_ACTION_NAME;
    }
    public static String getAutoFireOffActionName(){
	return AUTO_FIRE_OFF_ACTION_NAME;
    }

    /**
     * Overrides parent
     */
    public static double getTimeToShowIndirectFire(){
	return INDIRECT_FIRE_EXTEND_TIME;
    }

    /**
     * Overrides parent
     */
    public static double getIndirectFireExtendTime(WarUnitDKE3 wu){
	return INDIRECT_FIRE_EXTEND_TIME;
    }

    /**
     * Overrides parent
     */
    public static double getReloadExtendTime(){
	return RELOAD_EXTEND_TIME;
    }

    /**
     * Overrides parent
     */
    public static double getDisturbedTime(){
	return DISTURBED_TIME;
    }

    /**
     * Overrides parent
     */
    public static double getCombatExtendTime(){
	return COMBAT_EXTEND_TIME;
    }
    
    /**
     * Overrides parent
     */
    public static int getRegainStrengthTime(){
	return REGAIN_STRENGTH_TIME;
    }

        /**
     * Overrides parent
     */
    public static double speedFactorConverter(int intFactor){
	switch (intFactor){
	case 1:
	    return SPEED_FACTOR_ONE;
	case 2:
	    return SPEED_FACTOR_TWO;
	case 3:
	    return SPEED_FACTOR_THREE;
	case 4:
	    return SPEED_FACTOR_FOUR;
	case 5:
	    return SPEED_FACTOR_FIVE;
	default:
	    return SPEED_FACTOR_ONE;
	}
    }	

    /**
     * getInitialOpenRouteRange</code> returns the range from each WarUnit
     * that should be used to set open routs when initializing the game 
     * used by DKE3Referee.setInitialOpenRoute()
     *
     * @return an <code>int</code> value
     */
    public static int getInitialOpenRouteRange(){
	return new Double(getIndirectFireMaxRadius()).intValue();
    }

} // DefDKE3
