package gecco.server.referee;

import gecco.server.core.*;
import java.util.*;

/**
 * <p>
 * 
 * @author Hans Sandstrm
 * </p>
 */
public class Referee {

    private int scoreBlueTeam = 0; 
    private int scoreRedTeam = 0;

    public Referee(){
    }

    public Referee(gecco.server.clock.TimeUpdate timeUpdate){
	// if stop time is needed to be set, do it
    }
    
    public void unitDestroyed(Unit unit) {        
	System.out.println("Referee: unitDestoyed(" + unit + ")");
    }
    
    public void unitConqured(Unit unit, String oldOwner, String newOwner) {        
        if (oldOwner.equals(newOwner)){
            return; // No change in ownership
        }
        Integer unitValueAsInteger = (Integer) unit.getProperty("unitValue");
	if (unitValueAsInteger == null) {
	    unitValueAsInteger = new Integer(10); // Default value
	}
	int unitValue = unitValueAsInteger.intValue();
	
        if (oldOwner.equals("blue")){
            scoreBlueTeam -= unitValue;
            ReferenceHolder.out.println("gecco.server.referee.Referee: Blue team lost points");
        }
        else if (oldOwner.equals("red")){ 
            scoreRedTeam -= unitValue;
            ReferenceHolder.out.println("gecco.server.referee.Referee: Red team lost points");
        }
        if (newOwner.equals("blue")){
            scoreBlueTeam += unitValue;
	    ReferenceHolder.out.println("gecco.server.referee.Referee: Blue team earned points");
        }
        else if (newOwner.equals("red")){
            scoreRedTeam += unitValue;
            ReferenceHolder.out.println("gecco.server.referee.Referee: Red team earned points");
        }
	showScore();
    }

    public void showScore(){
	ReferenceHolder.out.println("Current score: Blue " + scoreBlueTeam + "p\n" +
				    "               Red  " + scoreRedTeam + "p");
    }

    public void timeIsUp(){
	stopGame();
    }

    private void stopGame(){
	ReferenceHolder.getClock().freeze(true);
	showScore();
	ReferenceHolder.out.println("Game stoped by referee, time is up.");
    }

    public void startReferee(){
    }

}



