package gecco.server.replaymanager;

/**
 * ReplayReady.java
 *
 *
 * Created: Wed May 07 14:47:49 2003
 *
 * @author <a href="mailto:hans.sandstrom@fhs.mil.se">Hans Sandstrm</a>
 * @version
 */

public interface ReplayReady {

    // Define supported types
    public final static int UNIT = 1;
    public final static int AUTOMATON = 2;
    public final static int MOVING_ACTION = 3;

    /**
     *
     * @param param1 <description>
     * @param param2 <description>
     *
     * Format description: TimeStamp Type Handle Method Parameters
     * TimeStamp  type: double    description: game time when method was called
     * Type       type: int       description: what type of object is executing the method
     *                                     currently only UNIT is valid
     * Handle     type: int       description: the handle for the type, currently unitHandle
     * Method     type: int       description: which method is called, handled by the implementor
     * Parameters type: Object[]  description: parameters to the method embedded in a Object[]
     *
     *
     * OBSERVE! Since replayLog is a ObjectOutputSteam all objects that should be written must 
     * implement the java.io.Serializable interface
     *
     */
    public void saveReplayData(int function, Object[] parameters);

    public void playReplayData(int function, Object[] parameters);


}// ReplayReady
